fsb.smartcontract-main/fsb.smartcontract/fsb.smartcontract/Controllers/DepartmentController.cs
using fsb.smartcontract.Services.Company;
using fsb.smartcontract.Services.Department;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using Model.Department;
using Model.Requests;
using NToastNotify;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;

namespace fsb.smartcontract.Controllers
{
    public class DepartmentController : BaseController
    {
        private readonly ILogger<DepartmentController> _logger;
        private readonly IToastNotification _toastNotification;
        private readonly IHttpContextAccessor _httpContextAccessor;
        private readonly IDepartmentService _departmentService;
        private readonly ICompanyService _companyService;

        public DepartmentController(
            ILogger<DepartmentController> logger,
            IHttpClientFactory factory,
            IToastNotification toastNotification,
            IHttpContextAccessor httpContextAccessor,
            IDepartmentService departmentService,
            ICompanyService companyService
            ) : base(factory)
        {
            _logger = logger;
            _toastNotification = toastNotification;
            _httpContextAccessor = httpContextAccessor;
            _departmentService = departmentService;
            _companyService = companyService;
        }

        [Route("danh-sach-phong-ban")]
        public IActionResult Departments()
        {
            return View();
        }

        [HttpPost]
        public IActionResult GetListDepartment(string searchValue)
        {
            SearchDepartmentModel searchModel = talbeSearchModel.Get<SearchDepartmentModel>();
            searchModel.SearchValue = searchValue;
            var data = _departmentService.GetListDepartment(searchModel);
            if (data.Code != StatusCodes.Status200OK)
                _toastNotification.AddErrorToastMessage(data.Message);
            return Json(data);
        }

        [Route("them-moi-phong-ban")]
        public IActionResult CreateDepartment()
        {
            ViewBag.GetListCompanyForCombo = _companyService.GetListCompanyForCombo();
            return View();
        }

        [HttpPost]
        public IActionResult InsertDepartment(DepartmentModel model)
        {
            var res = _departmentService.CreateDepartment(model);
            if (res.Code == StatusCodes.Status200OK)
            {
                _toastNotification.AddSuccessToastMessage(res.Message);
            }
            else
            {
                _toastNotification.AddErrorToastMessage(res.Message);
            }
            return Json(res);
        }

        [HttpPost]
        public IActionResult DeleteDepartment(int Id)
        {
            var model = new DepartmentModel();
            model.Id = Id;
            var res = _departmentService.DeleteCompany(model);
            if (res.Code == StatusCodes.Status200OK)
            {
                _toastNotification.AddSuccessToastMessage(res.Message);
            }
            else
            {
                _toastNotification.AddErrorToastMessage(res.Message);
            }
            return Json(res);
        }

    }
}

fsb.smartcontract-main/fsb.smartcontract/fsb.smartcontract/Views/Department/Departments.cshtml
@{
    ViewData["Title"] = "Departments";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<link href="~/css/app.css" rel="stylesheet" />
<div id="content">
    <!-- Begin Page Content -->
    <div class="container-fluid">

        <!-- Page Heading -->
        <h1 class="h3 mb-2 text-gray-800">Danh sách phòng ban</h1>
        <div class="h3 mb-2 row">
            <div class="col-md-12 col-lg-12">
                <a href="@Url.Action("CreateDepartment", "Department")" class="btn btn-success btn-icon-split">
                    <span class="icon text-white-50">
                        <i class="fas fa-plus"></i>
                    </span>
                    <span class="text">Thêm mới</span>
                </a>
            </div>
        </div>

        <!-- DataTales Example -->
        <div class="card shadow mb-4">
            <div class="card-body">
                <div class="form-group row" style="justify-content: flex-end">
                    <div class="col-md-12 col-lg-3 pr-0">
                        <input id="searchValue" class="form-control searchValue" type="text" placeholder="Tìm kiếm" />
                    </div>
                    <a class="btn btn-success btn-icon-split" onclick="reloadWithPageOne()">
                        <span class="icon text-white-50">
                            <i class="fas fa-search"></i>
                        </span>
                    </a>
                </div>
                <table class="table table-bordered" id="monthPlanningTbl" width="100%" cellspacing="0">
                    <thead>
                        <tr>
                            <th data-orderable="false">Tên công ty</th>
                            <th data-orderable="false">Mã phòng ban</th>
                            <th data-orderable="false">Tên phòng ban</th>
                            <th data-orderable="false">Thao tác</th>
                        </tr>
                    </thead>
                    <tfoot>
                    </tfoot>
                </table>
            </div>
        </div>
    </div>
    <!-- /.container-fluid -->
</div>
<div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Thông báo</h5>
                <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
            </div>
            <div class="modal-body">Bạn muốn xóa bản ghi này không?</div>
            <div class="modal-footer">
                <button class="btn btn-secondary" type="button" data-dismiss="modal">Hủy</button>
                <a class="btn btn-danger" onclick="DeleteDepartment()">Xóa</a>
            </div>
        </div>
    </div>
</div>
<script>
    var table = undefined;
    $(document).ready(function () {
        loadTable();
        $('#searchValue').keypress(function (e) {
            if (e.which == 13) {
                reloadWithPageOne();
            }
        });
    });
    function reloadWithPageOne() {
        if (table != undefined && table.api().ajax != undefined)
            table.api().ajax.reload(null, true);
    }
    function reload() {
        if (table != undefined && table.api().ajax != undefined)
            table.api().ajax.reload(null,false);
    }
    function loadTable() {
        table = $('#monthPlanningTbl').dataTable({
            "oLanguage": {
                "sEmptyTable": "Không có phòng ban"
            },
            "language": {
                "paginate": {
                    "previous": "Trước",
                    "next": "Tiếp theo"
                }
            },
            searching: false,
            paging: true,
            lengthChange: false,
            ordering: true,
            filter: false,
            destroy: true,
            orderMulti: false,
            serverSide: true,
            processing: true,
            lengthChange: false,
            "bSort": false,
            ajax: function (data, callback, settings) {
                data.searchValue = $('#searchValue').val();
                postTable("@Url.Action("GetListDepartment", "Department")", data, callback);
            },
            "columns": [
                { "data": "companyName", "name": "CompanyName", "class": "companyName" },
                { "data": "departmentCode", "name": "DepartmentCode", "class": "departmentCode" },
                { "data": "departmentName", "name": "DepartmentName", "class": "departmentName" },
                {
                    "class": "action",
                    "render": function (data, row, full) {
                        return "<a class='fas fa-fw fa-edit' title='Sửa' onclick=UpdateDepartment('" + full.id + "'); ></a> <a href='#' class='fas fa-fw fa-trash' style='color:red' title='Xóa' data-toggle='modal' data-target='#deleteModal' onclick=openConfirmDelete('" + full.id + "');></a>";
                    }
                }
            ]
        });
    }

    function openConfirmDelete(id) {
        deleteId = id;
    }

    function DeleteDepartment() {
        var formData = new FormData();
        formData.append("Id", deleteId);
        formData.append("__RequestVerificationToken", _token);
        postAjax('@Url.Action("DeleteDepartment")', formData, function (data) {
            $('#deleteModal').modal("hide");
            reload();
        });
    }

    function UpdateDepartment(id) {
        location.href = '/sua-phong-ban' + "/" + id;
    }
</script>